#
# timezone.rb
#
#     Copyright(c) 1998-1999 Minero Aoki
#     aamine@dp.u-netsurf.ne.jp
#


class Time

  def Time.zone_s2i( str )
    str.must String

    temp = nil

    case str
    when /jst/io then temp = 9
    when /([\+\-])(\d\d?)(\d\d)/o then
      min  = $2.to_i * 60 + $3.to_i
      if $1 == '-' then
        ret = min * (-1)
      else
        ret = min
      end
    when /gmt/io then temp = 0
    when /utc/io then temp = 0
    when /ut/io  then temp = 0
    when /edt/io then temp = -4
    when /est/io then temp = -5
    when /cdt/io then temp = -5
    when /cst/io then temp = -6
    when /mdt/io then temp = -6
    when /mst/io then temp = -7
    when /pdt/io then temp = -7
    when /pst/io then temp = -8
    when /a/io   then temp = -1
    when /b/io   then temp = -2
    when /c/io   then temp = -3
    when /d/io   then temp = -4
    when /e/io   then temp = -5
    when /f/io   then temp = -6
    when /g/io   then temp = -7
    when /h/io   then temp = -8
    when /i/io   then temp = -9
    # J not use
    when /k/io   then temp = -10
    when /l/io   then temp = -11
    when /m/io   then temp = -12
    when /n/io   then temp = 1
    when /o/io   then temp = 2
    when /p/io   then temp = 3
    when /q/io   then temp = 4
    when /e/io   then temp = 5
    when /s/io   then temp = 6
    when /t/io   then temp = 7
    when /u/io   then temp = 8
    when /v/io   then temp = 9
    when /w/io   then temp = 10
    when /x/io   then temp = 11
    when /y/io   then temp = 12
    when /z/io   then temp = 0
    else
      raise ArgumentError, "wrong timezone format '#{str}'"
    end

    if temp then ret = temp * 60 end

    return ret
  end


  def Time.zone_i2s( hour, min = 0 )
    hour.must Integer
    min.must  Integer

    if hour < -12 or hour > 12 then
      raise ArgumentError,
        "wrong hour value: #{hour}"
    end

    if min < 0 or min > 61 then
      raise ArgumentError,
        "wrong minute value: #{min}"
    end

    if hour < 0 then
      hour *= -1
      ret = '-'
    else
      ret = '+'
    end

    temp  = (hour * 100 + min).to_s
    ret << '0' * (4 - temp.size) << temp

    return ret
  end


  def Time.zone_s2s( str )
    temp = zone_s2i( str )
    zone_i2s( temp / 60, temp % 60 )
  end

end
